$(function() {
	var l = {
		extend: function(o) {
			var x;
			for (x in o) {
				this[x] = o[x];
			}
			return this;
		}
	};
	l.extend({
		set: function() {
			this.lineSvg = $('.line');
			this.path = $('.p');
		},
		listen: function() {
			var down = false,
				cc = null, /*当前圆圈*/
				tn = null, /*标签名*/
				em = null, /*坐标所在的元素*/
				pos = $('.pos'),
				path = [];
			/*
			* For PC
			*/
			if (typeof document.ontouchstart == 'undefined') {
				$('.shape circle').on('mousedown', function() {
					var circle = $(document.createElementNS('http://www.w3.org/2000/svg', 'circle')).attr({
						r: 12,
						cx: this.cx.animVal.value,
						cy: this.cy.animVal.value
					});
					l.lineSvg.append(circle);
					this.setAttribute('class', 'active');
					down = true;
					path.push('M' + this.cx.animVal.value + ' ' + this.cy.animVal.value);
				});
				$('svg').on('mousemove', function(e) {
					if (down) {
						l.path.attr('d', path.join(' ') + ' ' + 'L' + e.offsetX + ' ' + e.offsetY);
					}
				});
				$('.shape circle').on('mousemove', function(e) {
					if (down && cc != this && !this.hasAttribute('class')) {
						path.push('L' + this.cx.animVal.value + ' ' + this.cy.animVal.value);
						var circle = $(document.createElementNS('http://www.w3.org/2000/svg', 'circle')).attr({
							r: 12,
							cx: this.cx.animVal.value,
							cy: this.cy.animVal.value
						});
						l.lineSvg.append(circle);
						this.setAttribute('class', 'active');
						cc = this;
					}
				});
				$(document).on('mouseup', function() {
					down = false;
					l.path.attr('d', path.join(' '));
					mouseupEnd(path);
				});
			} else {
				/*
				* For mobile
				*/
				$('svg').on('touchstart', function(e) {
					var circle;
					em = document.elementFromPoint(e.originalEvent.touches[0].pageX, e.originalEvent.touches[0].pageY);
					if (em.tagName == 'circle' && !em.hasAttribute('class')) {
						circle = $(document.createElementNS('http://www.w3.org/2000/svg', 'circle')).attr({
							r: 12,
							cx: em.cx.animVal.value,
							cy: em.cy.animVal.value
						});
						l.lineSvg.append(circle);
						em.setAttribute('class', 'active');
						down = true;
						path.push('M' + em.cx.animVal.value + ' ' + em.cy.animVal.value);
					}
				});
				$('svg').on('touchmove', function(e) {
					e.preventDefault();
					if (!down) {
						return;
					}
					em = document.elementFromPoint(e.originalEvent.touches[0].pageX, e.originalEvent.touches[0].pageY);

					if (em.tagName == 'circle' && cc != em && !em.hasAttribute('class')) {
						var circle = $(document.createElementNS('http://www.w3.org/2000/svg', 'circle')).attr({
							r: 12,
							cx: em.cx.animVal.value,
							cy: em.cy.animVal.value
						});
						l.lineSvg.append(circle);
						path.push('L' + em.cx.animVal.value + ' ' + em.cy.animVal.value);
						em.setAttribute('class', 'active');
						cc = em;
					}
					l.path.attr('d', path.join(' ') + ' ' + 'L' + (e.originalEvent.touches[0].pageX - this.offsetLeft) + ' ' + (e.originalEvent.touches[0].pageY - this.offsetTop));
				});
				$(document).on('touchend', function() {
					down = false;
					l.path.attr('d', path.join(' '));
					console.log(path);
					touchEnd(path);
				});
			}
		},
		init: function() {
			this.set();
			this.listen();
		}
	});
	l.init();
});
