//只能是汉字 
//<input onkeyup="value="/oblog/value.replace(/[^\u4E00-\u9FA5]/g,'')"> 
var errormsg = '';
var notContain = ['/', ':', '*', '?','&','@', '"', '<', '>', '|', '.', '%3c', '%3e'];
//验证文本框是否合法 
function validate(txt,controlName) {
    if (txt == null || txt.length == 0 || typeof(txt)=='undefined') {
        errormsg = controlName+'不能为空。';
        return false;
    }
    if (txt.length > 50) {
        errormsg = controlName+'长度不能超过50个字符。';
        return false;
    }
    if (txt[0] == '.') {
        errormsg = controlName+'不能包括:/:*?"<>&@| 不能以.开头。';
        return false;
    }
    for (var i = 0; i < notContain.length; i++) {
        if (txt.indexOf(notContain[i]) > -1 && notContain[i] != '.') {
            errormsg = controlName+'不能包括:/:*?"<>&@| 不能以.开头。';
            return false;
        }
    }
    return true;
}

//验证允许为空
function validate_IsNull(txt,controlName) {
    if (txt.length > 50) {
        errormsg = controlName+'长度不能超过50个字符。';
        return false;
    }
    if (txt[0] == '.') {
        errormsg = controlName+'不能包括:/:*?"<>&@| 不能以.开头。';
        return false;
    }
    for (var i = 0; i < notContain.length; i++) {
        if (txt.indexOf(notContain[i]) > -1 && notContain[i] != '.') {
            errormsg = controlName+'不能包括:/:*?"<>&@| 不能以.开头。';
            return false;
        }
    }
    return true;
}

//只能是英文 
function onlyEng() {
	if (!(event.keyCode >= 65 && event.keyCode <= 90))
		event.returnvalue = false;
}

//只能是数字 
function onlyNum() {
	if (!((event.keyCode >= 48 && event.keyCode <= 57) || (event.keyCode >= 96 && event.keyCode <= 105)))
	//考虑小键盘上的数字键 
		event.returnvalue = false;
}

//验证油箱格式 
function isEmail(strEmail) {
		if (strEmail.search(/^\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/) != -1)
			return true;
		else
			return false;
	}
	//<input type=text onblur=isEmail(this.value)> 


//中文/英文/数字/邮件地址合法性判断 

function isEnglish(name) //英文值检测 
	{
		if (name.length == 0)
			return false;
		for (i = 0; i < name.length; i++) {
			if (name.charCodeAt(i) > 128)
				return false;
		}
		return true;
	}

function isChinese(name) //中文值检测 
	{
		if (name.length == 0)
			return false;
		for (i = 0; i < name.length; i++) {
			if (name.charCodeAt(i) > 128)
				return true;
		}
		return false;
	}

function isNumber(name) //数值检测 
	{
		var reg=/^([+-]?)\d*\.?\d+$/;
		return reg.test(name);
	}

//限定表单项不能输入的字符 
function contain(str, charset) //  字符串包含测试函数 
	{
		var i;
		for (i = 0; i < charset.length; i++)
			if (str.indexOf(charset.charAt(i)) >= 0)
				return true;
		return false;
	}


//判断是否包含汉字  
function isContainChinese(str) {
	if (/[^\x00-\xff]/g.test(str)) {
		return true;
	} else {
		return false;
	}

}

//电话号码格式验证    
//---------------------------------------      
//函数名：fucCheckTEL     
//功能介绍：检查是否为电话号码     
//参数说明：要检查的字符串     
//返回值：1为是合法，0为不合法     
function isTEL(TEL) {
	var i, j, strTemp;
	strTemp = "0123456789-()# ";
	for (i = 0; i < TEL.length; i++) {
		j = strTemp.indexOf(TEL.charAt(i));
		if (j == -1) {
			//说明有字符不合法     
			return true;
		}
	}
	//说明合法     
	return false;
}

//限制输入字符的位数开始  
//m是用户输入，n是要限制的位数  
function isValidateLength(m, n) {
	if ((m < n) && (m > 0)) {
		return false;
	} else {
		return true;
	}
}

//判断用户名是否为数字字母下滑线   
function CheckForm(str) {
	var reg = /[^A-Za-z0-9_]/g
	if (reg.test(str)) {
		return false;
	} else {
		return true;
	}
}

//表单项只能为数字和"_",用于电话/银行帐号验证上,可扩展到域名注册等 


function isNumber(String) {
	var Letters = "1234567890-"; //可以自己增加可输入值 
	var i;
	var c;
	if (String.charAt(0) == '-')
		return false;
	if (String.charAt(String.length - 1) == '-')
		return false;
	for (i = 0; i < String.length; i++) {
		c = String.charAt(i);
		if (Letters.indexOf(c) < 0)
			return false;
	}
	return true;
}