var wgtVer = null;

function plusReady() {
	// 获取本地应用资源版本号
	plus.runtime.getProperty(plus.runtime.appid, function(inf) {
		wgtVer = inf.version;
		//		alert(plus.runtime.appid)
		$.ajax({
			type: 'post',
			dataType: 'JSONP',
			url: CloudIp + 'hold_LoadInit?AppSn=' + localStorage["sn"],
			jsonp: "callback",
			success: function(result) {
				if (result) {
					if (result.isSuccess && result.result.length > 0 && result.result[0][0].AllowUpdate == '1') {
						checkUpdate();
					}
				}
			},
			error: function(XmlHttpRequest, textStatus, errorThrown) {
				mui.toast('服务器异常。');
			}
		});

		//		console.log("当前应用版本：" + wgtVer);
	});
}
if (window.plus) {
	plusReady();
} else {
	document.addEventListener('plusready', plusReady, false);
}
// 下载wgt文件
var wgtUrl = '';

function checkUpdate() {
	plus.nativeUI.showWaiting("检测更新...");
	$.ajax({
		type: 'post',
		dataType: 'JSONP',
		url: CloudIp + "hold_getVersion?AppID=" + plus.runtime.appid + "&AppSys=Android",
		jsonp: "callback",
		success: function(result) {
			if (result) {
				plus.nativeUI.closeWaiting();
				if (result.isSuccess) {
					if (result.result[0].length > 0) {
						var newVer = result.result[0][0].AppVersion;
						if (wgtVer && newVer && (wgtVer != newVer)) {
							localStorage["first"] = '';
							wgtUrl = result.result[0][0].AppUpdateUrl + result.result[0][0].AppID + '.apk';
							downWgt(); // 下载升级包
						} else {
							//							plus.nativeUI.alert("无新版本可更新！");
						}
					}
				} else {
					plus.nativeUI.alert("检测更新失败！");
				}
			} else {
				mui.toast('服务器未正确响应。');
			}
		},
		error: function(XmlHttpRequest, textStatus, errorThrown) {
			mui.toast('服务器异常。');
		}
	});
}


function downWgt() {
	plus.nativeUI.showWaiting("下载更新文件...");
	plus.downloader.createDownload(wgtUrl, {
		filename: "_doc/update/"
	}, function(d, status) {
		plus.nativeUI.closeWaiting();
		if (status == 200) {
			installWgt(d.filename); // 安装wgt包
		} else {
			plus.nativeUI.alert("下载更新失败！");
		}
	}).start();
}

// 更新应用资源
function installWgt(path) {
	plus.nativeUI.showWaiting("安装更新文件请勿取消...");
	plus.runtime.install(path, {}, function() {
		plus.nativeUI.closeWaiting();
		plus.nativeUI.alert("应用资源更新完成！", function() {
			plus.runtime.restart();
		});
	}, function(e) {
		plus.nativeUI.closeWaiting();
		plus.nativeUI.alert("安装更新文件失败[" + e.code + "]：" + e.message);
	});
}