

//作者：Copy
//时间：2015-10-28
//描述：上传下载动作

var wt = null;
var server = getServletUrl('appUpLoad');
//压缩图片
function compressImage(path, n, ft, oldpath) {
	wt = plus.nativeUI.showWaiting();
	plus.zip.compressImage({ 
			src: plus.os.name == 'Android' ? path : oldpath,
			dst: "_doc/audio/" + n,
			quality: 80,
			overwrite: true
		},
		function() {
			upload("_doc/audio/" + n, n, ft);
		},
		function(error) {
			alert("文件压缩错误：" + path);
		});
}

// 上传文件
function upload(path, n, ft) {
	var task = plus.uploader.createUpload(server + "?fp=DangerConsultationFilePath", {
			method: "POST"
		},
		function(t, status) { //上传完成
			if (status == 200) {
				//							mui.toast("上传成功：" + t.responseText);
				var resultObj = $.parseJSON(t.responseText);
				//							cleanHistory();
				window.filetype = ft;
				window.filename = resultObj.fileName;
				window.timelength = Math.round(dsn / 1000);
				if (ft != "pic") {
					createDownloadTask(resultObj.fileName, true);
				} else {
					//					mui.previewImage(); 
					CHAT.submit();
				}
			} else {
				mui.toast("上传失败：" + status);
			}
			if (ft != "audio") {
				wt.close();
			}
		}
	);
	task.addFile(path, {
		key: n
	});
	task.start();
}
var dtask = null;

function createDownloadTask(filename, isme) {
	var url = server + "?n=" + filename + "&fp=DangerConsultationFilePath";
	var options = {
		method: "GET",
		filename: "_doc/audio/" + filename
	};
	dtask = plus.downloader.createDownload(url, options);
	dtask.addEventListener("statechanged", function(task, status) {
		if (!dtask) {
			return;
		}
		switch (task.state) {
			case 1: // 开始
				break;
			case 2: // 已连接到服务器
				break;
			case 3: // 已接收到数据
				break;
			case 4: // 下载完成
				if (isme) {
					CHAT.submit();
				}
				//														mui.toast("下载完成！");
				//							startPlay("_doc/audio/" + filename);
				break;
		}
	});
	//								mui.toast("创建下载任务成功！");
	dtask.start();
}
//作者：Copy
//时间：2015-10-28
//描述：录音播放业务控制
var gentry = null,
	hl = null,
	le = null;
var er = null,
	ep = null;
// H5 plus事件处理
function plusReady() {
	// 获取音频目录对象
	plus.io.resolveLocalFileSystemURL("_doc/", function(entry) {
		entry.getDirectory("audio", {
			create: true
		}, function(dir) {
			gentry = dir;
		}, function(e) {
			//outSet("Get directory \"audio\" failed: " + e.message);
		});
	}, function(e) {
		//outSet("Resolve \"_doc/\" failed: " + e.message);
	});
}
if (window.plus) {
	plusReady();
} else {
	document.addEventListener("plusready", plusReady, false);
}
// 开始录音
var r = null,
	t = 0,
	ri = null,
	rt = null;

function startRecord() {
	//					mui.toast("开始录音：");
	r = plus.audio.getRecorder();
	if (r == null) {
		mui.toast("录音对象未获取");
		return;
	}
	r.record({
		filename: "_doc/audio/"
	}, function(p) {
		//						mui.toast("录音完成：" + p);
		plus.io.resolveLocalFileSystemURL(p, function(entry) {
			if (!isCancel) {
				upload("_doc/audio/" + entry.name, entry.name, "audio");
			}
		}, function(e) {
			mui.toast("读取录音文件错误：" + e.message);
		});
	}, function(e) {
		mui.toast("录音失败：" + e.message);
	});
	t = 0;
}
// 停止录音

function stopRecord() {
	r.stop();
	w = null;
	r = null;
	t = 0;
}
// 清除历史记录

function cleanHistory() {
	// 删除音频文件
	gentry.removeRecursively(function() {
		// Success
		//						mui.toast("操作成功！");
	}, function(e) {
		mui.toast("操作失败：" + e.message);
	});
}
// 播放音频文件

function playAudio(entry) {
	if (!entry) {
		mui.toast("无效的音频文件");
		return;
	}
	//					mui.toast("播放音频文件：" + entry.name);
	startPlay("_doc/audio/" + entry.name);
}
// 播放文件相关对象
var p = null,
	pt = null,
	pp = null,
	ps = null,
	pi = null;
// 开始播放
function startPlay(url) {
	if (p) {
		p.stop();
		p = null;
		return false;
	}
	p = plus.audio.createPlayer(url);
	p.setRoute(plus.audio.ROUTE_SPEAKER);

	p.play(function() {
		//									mui.toast("播放完成！");
		// 播放完成
		stopPlay();
	}, function(e) {
		mui.toast("播放音频文件\"" + url + "\"失败：" + e.message);
	});
}
// 停止播放

function stopPlay() {
	// 操作播放对象
	if (p) {
		p.stop();
		p = null;
	}
}

//作者：Copy
//时间：2015-10-28
//描述：监听按住说话操作并计时按下时间及动画效果
var duration = null,
	counter = null,
	loading = null;

var audio_tips = null;
var recordCancel = false;
var isCancel = false;
document.addEventListener("plusready", function() {
	duration = document.getElementById("sayContainer");
	duration.addEventListener("touchstart", durationStart, false);
	duration.addEventListener("touchend", durationEnd, false);
	audio_tips = document.getElementById("audio_tips");
	document.getElementById("sayContainer").addEventListener('drag', function(event) {
		if (Math.abs(event.detail.deltaY) > 50) {
			if (!recordCancel) {
				isCancel = true;
				recordCancel = true;
				if (!audio_tips.classList.contains("cancel")) {
					audio_tips.classList.add("cancel");
				}
				audio_tips.innerHTML = "松开手指，取消发送";
			}
		} else {
			if (recordCancel) {
				isCancel = false;
				recordCancel = false;
				if (audio_tips.classList.contains("cancel")) {
					audio_tips.classList.remove("cancel");
				}
				audio_tips.innerHTML = "手指上划，取消发送";
			}
		}
	}, false);
}, false);
var ds = null;
var dsn = null;

function durationStart() {
	ds = new Date();
	isCancel = false;
	recordCancel = false;
	if (audio_tips.classList.contains("cancel")) {
		audio_tips.classList.remove("cancel");
	}
	audio_tips.innerHTML = "手指上划，取消发送";
	$("#sound-alert").fadeIn(500, function() {});
	startRecord();
}

function durationEnd() {
	dsn = (new Date()).getTime() - ds.getTime();
	var delayTime = 500;
	var warting = 0;
	if (Math.round(dsn / 1000) < 1) {
		isCancel = true;
		delayTime = 1500;
		warting = 1000;
		audio_tips.innerHTML = "录音时间太短";
	}
	stopRecord();
	$("#sound-alert").delay(warting).fadeOut(delayTime, function() {});
}

//作者：Copy
//时间：2015-10-28
//描述：页面初始化及动作事件绑定
window.onload = function() {
	var w_height = 0;

	mui.init({
		swipeBack: false,
	});

	function GetRandomNum(Min, Max) {
		var Range = Max - Min;
		var Rand = Math.random();
		return (Min + Math.round(Rand * Range));
	}
	var num = GetRandomNum(1, 36);
	window.userLogoPath = "../../../Images/resources/userlogo/" + num + ".png";
	window.filetype = "txt";
	window.filename = "";

	//解决输入法自带收起功能导致文本框不归位的问题
	window.onresize = function() {

		if (w_height != 0 && window.innerHeight > w_height) {
			$("body").css({
				"border": "0px solid #FFFFFF"
			});
			$(".input-box").css({
				"position": "absolute",
				"bottom": 0 + "px",
			});
			$("#content").blur();
		} else {
			$("body").css({
				"border": "1px solid #FFFFFF"
			});
			$(".input-box").css({
				"position": "fixed",
				"bottom": 0 + "px",
			});

		}
		w_height = window.innerHeight;
	}
	document.getElementById("addMedia").addEventListener('tap', function(event) {
		var btnArray = [{
			title: "拍照"
		}, {
			title: "从相册选择"
		}];
		plus.nativeUI.actionSheet({
			title: "选择照片",
			cancel: "取消",
			buttons: btnArray
		}, function(e) {
			var index = e.index;
			switch (index) {
				case 0:
					break;
				case 1:
					var cmr = plus.camera.getCamera();
					cmr.captureImage(function(path) {
						var spath = plus.io.convertLocalFileSystemURL(path);
						compressImage(spath, spath.substring(spath.lastIndexOf("/") + 1), "pic", path);
					}, function(err) {});
					break;
				case 2:
					plus.gallery.pick(function(path) {
						var spath = plus.io.convertLocalFileSystemURL(path);
						compressImage(spath, spath.substring(spath.lastIndexOf("/") + 1), "pic", path);
					}, function(err) {}, null);
					break;
			}
		});
	}, false);
	$("#mjr_send").on("tap", function() {
		sendText();
	});
	$(document).on("tap", "img[data-flag='mesgimg']", function() {
		var idx = 0;
		var imgs = [];
		var thisPath = $(this).attr("src");
		$("img[data-flag='mesgimg']").each(function() {
			if ($(this).attr("src") == thisPath) {
				localStorage["thisIndex"] = idx;
			}
			imgs.push($(this).attr("src"));
			idx++;
		});

		localStorage["RealCommunication"] = JSON.stringify(imgs);

		localStorage["OpenFrom"] = "RealCommunication";
		plus.navigator.setFullscreen(true);
		mui.openWindow({
			url: 'DangerConsultationPicShow.html',
			id: 'DangerConsultationPicShow.html',
			createNew: false, //是否重复创建同样id的webview，默认为false:不重复创建，直接显示
			show: {
				autoShow: true, //页面loaded事件发生后自动显示，默认为true
				aniShow: 'slide-in-right', //页面显示动画，默认为”slide-in-right“；
				duration: '400' //页面动画持续时间，Android平台默认100毫秒，iOS平台默认200毫秒；
			},
			waiting: {
				autoShow: true, //自动显示等待框，默认为true
				title: '正在加载...'
			}
		});
	});
	CHAT.logout = function() {
		plus.webview.currentWebview().close();
	}
	setTimeout(function() {
		CHAT.usernameSubmit(localStorage["StaffName"] ? localStorage["StaffName"] : "游客");
	}, 100);
	//绑定语音部分功能 
	Record();
}

function sendText() {
	window.filetype = "txt";
	window.filename = "";
	window.timelength = 0;
	CHAT.submit();
}

function Record() {
	//语音交互部分
	$("#Record").on("tap", function() {
		if ($("#content").css("display") == "block") {
			$(this).css("background", "url(../../../css/Projects/LIS.Module.DangerConsultation/WebSocket/Images/msg.png)");
			$("#mjr_send").css("display", "none");
			$("#hideaddMedia").css("display", "block");
			$("#content").css("display", "none");
			$("#sayContainer").css("display", "block");
		} else {
			$(this).css("background", "url(../../../css/Projects/LIS.Module.DangerConsultation/WebSocket/Images/Record.png)");
			$("#mjr_send").css("display", "block");
			$("#hideaddMedia").css("display", "none");
			$("#content").css("display", "block");
			$("#sayContainer").css("display", "none");
		}
	});
}