//  PointSet.js
//  <project>
//  簇层
//  Created by Administrator on 2016-06-17.
//  Copyright 2016 Administrator. All rights reserved.
function addClusters(resp, resp1) {
	require(["extras/ClusterLayer", "dojo/_base/array"],
		function loadmap(ClusterLayer, arrayUtils) {
			var photoInfo = {};
			photoInfo.data = arrayUtils.map(resp, function(p) {
				var latlng = new esri.geometry.Point(parseFloat(p.Longitude), parseFloat(p.Latitude), wgs);
				//	var webMercator = webMercatorUtils.geographicToWebMercator(latlng);
				var strLable;
				// 增加标注字段，存储要素的标注值   
				strLable = "<table style=\"heigth:auto; \"><tr><td><p style=\'font-weight:bold;\'>" + p.MonitorName + "&nbsp;<br></p></td><td><img src=\"../../../Images/Gis/LableClose.png\" style=\"width: 24px; height: 24px;\" onClick=\"Infohide();\"/></td></tr>";
				//strLable = "<table><tr><td><p>" + result.result[0][i].MonitorName + "</p></td><td><div class=\"close\" title=\"关闭\"></div></td></tr>";
				strLable += "<tr><td><hr></td></tr>";
				if(p.JData != null && p.JData.indexOf("|") != -1) {
					strLable += "<tr><td><p style=\"width:100%; display:inline-block; \" class='mui-ellipsis'>开始时间:" + p.JData.split("|")[0] + "</p></td><td></td></tr>";
					strLable += "<tr><td><p style=\"width:100%; display:inline-block; \" class='mui-ellipsis'>结束时间:" + p.JData.split("|")[1] + "</p></td><td></td></tr>";
				} else {
					strLable += "<tr><td><p style=\"width:100%; display:inline-block; \" class='mui-ellipsis'>监测时间:" + p.JData + "</p></td><td></td></tr>";
				}
				for(j = 0; j < resp1.length; j = j + 1) {
					if(p.MonitorID == resp1[j].MonitorID) {
						//替换单位 
						re1 = new RegExp("立方米", "g");
						resp1[j].ShowNote = resp1[j].ShowNote.replace(re1, "m³");
						re2 = new RegExp("平方米", "g");
						resp1[j].ShowNote = resp1[j].ShowNote.replace(re2, "㎡");
						re2 = new RegExp("秒", "g");
						resp1[j].ShowNote = resp1[j].ShowNote.replace(re2, "s");
						if(resp1[j].NoteY == "颜色报警" && resp1[j].Value != "--") {
							strLable += "<tr><td><p style=\"width:100%; display:inline-block; \" class='mui-ellipsis'>" + resp1[j].Note + "：";
							//添加颜色块
							var Color = resp1[j].Value.split(',');
							var h = 0;
							for(h = 0; h < Color.length; h++) {
								strLable += "<span onclick='duihua(\"" + Color[h] + "\")' style=\"background: " + Color[h] + "; margin-left: 5px; \" >&nbsp;&nbsp;&nbsp;&nbsp;</span>";
							}
							strLable += "<br><label id=\"WarnLable\" style=\"display:none;font-size:15px;height: 15px;\">dfdsf</label></p></td><td></td></tr>"
						} else {
							strLable += "<tr><td><p style=\"width:100%; display:inline-block; \" class='mui-ellipsis'>" + resp1[j].ShowNote + "</p></td><td></td></tr>";
						}
					}
				}
				strLable += "</table>";
				//mui.toast(strLable) ;
				//console.log(strLable);
				//每个要素的属性值     
				var attribute = {
					"MonitorID": p.MonitorID,
					"MonitorType": p.MonitorType,
					"MeasureType": p.MeasureType,
					"MonitorName": p.MonitorName,
					"ShortName": p.ShortName,
					"MonitorLable": strLable
				};
				return {
					"x": latlng.x,
					"y": latlng.y,
					"attributes": attribute
				};
			});
			if(graphicsLayer != null) {
				for(var i in photoInfo.data) {
					graphicsLayer._clusterDataBat.push(photoInfo.data[i]);
				}
				graphicsLayer._refush();
			} else {
				graphicsLayer = new ClusterLayer({
					"data": photoInfo.data,
					"distance": 50,
					"labelColor": "#fff",
					"labelOffset": 10,
					"showSingles": true,
					"spatialReference": wgs,
					"maxSingles": 10
				});
				graphicsLayer.id = "MonitorsLayer";
				//设置图层可见比例尺。
				//graphicsLayer.setScaleRange(localStorage["minScale"], localStorage["maxScale"]);
				//要素类唯一值渲染
				var renderer = UniqueValueRendererMeth();
				graphicsLayer.setRenderer(renderer);
				map.addLayer(graphicsLayer);
			}
			//测点层添加到地图框架里
			graphicsLayer.redraw()
			plus.nativeUI.closeWaiting();
		})
}

function duihua(strcolor) {
	var avt = "";
	for(t = 0; t < WarnArray.length; t = t + 1) {
		if(WarnArray[t].WarnColor == strcolor) {
			avt = WarnArray[t].ItemName;
		}
	}
	$("#WarnLable").fadeIn()
	$("#WarnLable").html(avt);
	$("#WarnLable").delay(1000).fadeOut(700)
}

//  PointSet.js
//  <project>
//  渲染要素方法，每个要素的渲染符号
//  Created by Administrator on 2016-03-10.
//  Copyright 2016 Administrator. All rights reserved.
function UniqueValueRendererMeth() {
	var defaultSymbol = new esri.symbol.PictureMarkerSymbol("../../../Images/Gis/Pin1Blue.png", 40, 40).setOffset(0, 15);
	var renderer = new esri.renderer.UniqueValueRenderer(defaultSymbol, "MonitorType");
	renderer.addValue("01", new esri.symbol.PictureMarkerSymbol("../../../Images/Gis/012.png", 15, 15));
	renderer.addValue("02", new esri.symbol.PictureMarkerSymbol("../../../Images/Gis/024.png", 15, 15));
	renderer.addValue("03", new esri.symbol.PictureMarkerSymbol("../../../Images/Gis/038.png", 15, 15));
	renderer.addValue("04", new esri.symbol.PictureMarkerSymbol("../../../Images/Gis/0416.png", 15, 15));
	renderer.addValue("05", new esri.symbol.PictureMarkerSymbol("../../../Images/Gis/0532.png", 15, 15));
	renderer.addValue("06", new esri.symbol.PictureMarkerSymbol("../../../Images/Gis/0664.png", 15, 15));
	return renderer;
}

//  PointSet.js
//  <project>
//  标注窗体关闭事件
//  Created by Administrator on 2016-03-15.
//  Copyright 2016 Administrator. All rights reserved.
function Infohide() {
	//$(".esriPopupVisible").attr("style", "visibility:hidden ");
	//$(".esriPopupVisible").remove();
	//$(".esriPopupVisible").attr("style", "display: none");
	//map.infoWindow.hide();
	graphicsLayer._map.infoWindow.hide();
	$(".contentPane").html("");
};

//  PointSet.js
//  <project>
//  主页面四个功能页面切换，并且只能显示一个。
//  Created by Administrator on 2016-03-15.
//  Copyright 2016 Administrator. All rights reserved.
function mainbutton(tts) {
	if(document.getElementById(tts.alt).style.display == 'none') {
		if(tts.alt != "SearchPage") {
			document.getElementById('SearchPage').style.display = 'none';
			document.getElementById('search').src = "../../../Images/Gis/search2.png";
			document.getElementById('search').style.backgroundColor = 'rgba(145, 144, 142, 0.7)';
			document.getElementById('search').style.border = '';
		} else {
			SearchLoad();
		}
		if(tts.alt != "SetingPage") {
			document.getElementById('SetingPage').style.display = 'none';
			document.getElementById('main_Set').src = "../../../Images/Gis/main_Set2.png";
			document.getElementById('main_Set').style.backgroundColor = 'rgba(145, 144, 142, 0.7)';
			document.getElementById('main_Set').style.border = '';
		}
		if(tts.alt != "ChangePage") {
			document.getElementById('ChangePage').style.display = 'none';
			document.getElementById('change').src = "../../../Images/Gis/change2.png";
			document.getElementById('change').style.backgroundColor = 'rgba(145, 144, 142, 0.7)';
			document.getElementById('change').style.border = '';
		}
		if(tts.alt != "PicturePage") {
			document.getElementById('PicturePage').style.display = 'none';
			document.getElementById('picyure').src = "../../../Images/Gis/picyure2.png";
			document.getElementById('picyure').style.backgroundColor = 'rgba(145, 144, 142, 0.7)';
			document.getElementById('picyure').style.border = '';
		}
		document.getElementById(tts.alt).style.display = 'block';
		tts.src = "../../../Images/Gis/" + tts.id.toString() + "1.png";
		tts.style.backgroundColor = 'white';
		tts.style.border = '1px solid rgba(145, 144, 142, 0.7)';
	} else {
		document.getElementById(tts.alt).style.display = 'none';
		tts.src = "../../../Images/Gis/" + tts.id.toString() + "2.png";
		tts.style.backgroundColor = 'rgba(145, 144, 142, 0.7)';
		tts.style.border = '';
	}
}

//  PointSet.js
//  <project>
//  主页面“切换”功能使用
//  Created by Administrator on 2016-03-15.
//  Copyright 2016 Administrator. All rights reserved.
function changemap(mapimage) {
	if(mapimage.id == "pingmian" && mapimage.alt == "unselect") {
		document.getElementById('pingmian').src = '../../../Images/Gis/pingmian2.png';
		document.getElementById('pingmian').alt = 'select';
		document.getElementById('weixing').src = '../../../Images/Gis/weixing1.png';
		document.getElementById('weixing').alt = 'unselect';
		document.getElementById('guanqu').src = '../../../Images/Gis/guanqu1.png';
		document.getElementById('guanqu').alt = 'unselect';
		map.getLayer("baseTiledmap").hide();
		googleMapLayer.show();
	} else if(mapimage.id == "weixing" && mapimage.alt == "unselect") {
		document.getElementById('pingmian').src = '../../../Images/Gis/pingmian1.png';
		document.getElementById('pingmian').alt = 'unselect';
		document.getElementById('weixing').src = '../../../Images/Gis/weixing2.png';
		document.getElementById('weixing').alt = 'select';
		document.getElementById('guanqu').src = '../../../Images/Gis/guanqu1.png';
		document.getElementById('guanqu').alt = 'unselect';
		map.getLayer("baseTiledmap").hide();
		googleMapLayer.hide();
		googleImageLayer.show();
	} else if(mapimage.id == "guanqu" && mapimage.alt == "unselect") {
		document.getElementById('pingmian').src = '../../../Images/Gis/pingmian1.png';
		document.getElementById('pingmian').alt = 'unselect';
		document.getElementById('weixing').src = '../../../Images/Gis/weixing1.png';
		document.getElementById('weixing').alt = 'unselect';
		document.getElementById('guanqu').src = '../../../Images/Gis/guanqu2.png';
		document.getElementById('guanqu').alt = 'select';
		map.getLayer("baseTiledmap").show();
		googleImageLayer.hide();
		googleMapLayer.show();
	}
}

//  PointSet.js
//  <project>
//  主页面“设置”功能使用
//  Created by Administrator on 2016-03-15.
//  Copyright 2016 Administrator. All rights reserved.
function checkboxOnclick(chk) {
	//console.log(chk.checked+","+chk.value)
	if(chk.checked == true) {
		GisQueryPoint(chk.value);
	} else {
		//var dels = [];
		if(graphicsLayer != null && graphicsLayer._clusterDataBat != null) {
			for(var i = graphicsLayer._clusterDataBat.length - 1; i >= 0; i--) {
				if(graphicsLayer._clusterDataBat[i].attributes.MonitorType.indexOf(chk.value) != -1) {
					graphicsLayer._clusterDataBat.splice(i, 1);
					continue;
				}
			}
			graphicsLayer._refush();
		}
	}
}

//  PointSet.js
//  <project>
//  主页面“搜索”功能使用——搜索窗体初始化准备工作
//  Created by Administrator on 2016-03-15.
//  Copyright 2016 Administrator. All rights reserved.
var TempArr = []; //存贮option
function SearchLoad() {
	TempArr = [];
	/*先将数据存入数组*/
	if(graphicsLayer != null && graphicsLayer._clusterDataBat != null) {
		for(var i in graphicsLayer._clusterDataBat) {
			TempArr[i] = [graphicsLayer._clusterDataBat[i].attributes["ShortName"], graphicsLayer._clusterDataBat[i].attributes["ShortName"]];
		}
	}
	document.getElementById('txtsearch1').value = '搜索测点';
	document.getElementById('myselect').style.height = 'auto';
	Clean();
}

//  PointSet.js
//  <project>
//  主页面“搜索”功能使用——模糊查找窗体初始准备工作
//  Created by Administrator on 2016-03-15.
//  Copyright 2016 Administrator. All rights reserved.
function Clean() {
	//清除ul下的所有li
	$('ul.Seaoption').html("");
	//去掉模糊查找窗体的边框
	document.getElementById('myselect').style.border = '';
	document.getElementById('myselect').style.height = 'auto';
}

//  PointSet.js
//  <project>
//  主页面“搜索”功能使用——搜索模糊查找事件
//  Created by Administrator on 2016-03-15.
//  Copyright 2016 Administrator. All rights reserved.
function SelectTip(flag) {
	var TxtObj = document.getElementById("txtsearch1").value;
	if(TxtObj == "") {
		Clean();
	} else {
		var SelectObj = document.getElementById("myselect")
		var Arr = []
		with(SelectObj) {
			var SelectHTML = innerHTML.match(/<[^>]*>/)[0]
			for(i = 0; i < TempArr.length; i++)
				if(TempArr[i][0].indexOf(TxtObj) != -1 || flag) //若找到以txt的内容开头的，添option。若flag为true,对下拉框初始化
					Arr[Arr.length] = "<li onclick='txtsearch1.value=this.innerText; Clean();'>" + TempArr[i][0] + "</li>"
			innerHTML = SelectHTML + Arr.join(" ") + "</ul>"
		}
		if(Arr.length > 0) {
			//添加模糊查找窗体的边框样式
			document.getElementById('myselect').style.border = '1px solid rgba(145, 144, 142, 0.7)';
		} else {
			Clean();
		}
		if(Arr.length > 6) {
			//添加模糊查找窗体的边框样式
			document.getElementById('myselect').style.height = '190px';
		} else {
			document.getElementById('myselect').style.height = 'auto';
		}
	}
}

//  PointSet.js
//  <project>
//  主页面“搜索”功能使用——定位按钮
//  Created by Administrator on 2016-03-15.
//  Copyright 2016 Administrator. All rights reserved.
var mygraphics = new Array();

function onclickSearch() {
	var sFind = document.getElementById("txtsearch1").value;
	if(sFind == "" || sFind == "搜索测点") {
		mui.toast("请输入搜索内容。");
	} else {
		mygraphics = []; //清空Array数组
		if(graphicsLayer != null && graphicsLayer._clusterDataBat != null) {
			for(var i in graphicsLayer._clusterDataBat) {
				if(graphicsLayer._clusterDataBat[i].attributes["ShortName"].indexOf(sFind) != -1) {
					mygraphics.push(graphicsLayer._clusterDataBat[i]);
				}
			}
		}
		if(mygraphics.length == 0) {
			mui.toast("未搜索到相应测点。");
		} else {
			//设置显示中心点
			//map.centerAndZoom(mygraphics[0].geometry);
			//var cPoint= new esri.geometry.Point(106.63627288238668, 27.027733110525226);
			var point = new esri.geometry.Point(mygraphics[0].x, mygraphics[0].y, map.spatialReference);
			var maxZoom = map.getMaxZoom();
			map.setZoom(maxZoom - 1);
			map.centerAt(point);
		}
	}
}

//  PointSet.js
//  <project>
//  进行Identify功能
//  Created by Administrator on 2016-04-28.
//  Copyright 2016 Administrator. All rights reserved.
//进行Identify
function doIdentify(evt) {
	plus.nativeUI.showWaiting("正在加载...", {
		padlock: false
	});
	//清除上一次的高亮显示
	//LocationLayer.clear();
	map.infoWindow.hide();
	screenPoint = evt.screenPoint
		//Identify的geometry
	identifyParams.geometry = evt.mapPoint;
	//Identify范围
	identifyParams.mapExtent = map.extent;
	identifyTask.execute(identifyParams, function(idResults) {
		if(idResults.length == 0) {
			plus.nativeUI.closeWaiting();
		}
		var Choicegra = null;
		for(var i = 0; i < idResults.length; i++) {
			if(localStorage["IdenQur"].indexOf("(" + idResults[i].layerId + ")") != -1) {
				Choicegra = idResults[i];
				break;
			}
		}
		if(Choicegra != null) {
			addToMap(Choicegra);
		} else {
			plus.nativeUI.closeWaiting();
		}
	});
}

function addToMap(idResult) {
	//Identify结果
	var URL = getHostUrl("GisHandle_EclipIdenInit?layerName=" + idResult.layerName + "&LinkID=" + idResult.feature.attributes["LinkID"]);
	$.ajax({
		type: 'post',
		dataType: 'JSONP',
		url: URL,
		jsonp: "callback",
		success: function(result) {
			if(result) {
				if(result.isSuccess) {
					//alert(result.result[0].length);
					// 增加标注字段，存储要素的标注值   
					var strinfo;
					strinfo = "<table style=\"heigth:auto; \"><tr><td><p style=\'font-weight:bold;\'>" + idResult.feature.attributes["Name"] + "&nbsp;<br></p></td><td><img src=\"../../../Images/Gis/LableClose.png\" style=\"width: 24px; height: 24px;\" onClick=\"Infohide();\"/></td></tr>";
					strinfo += "<tr><td><hr></td></tr>";
					var Nolis = result.result[1];
					for(j = 0; j < Nolis.length; j = j + 1) {
						var Columid = Nolis[j].Note;
						//单位 
						var unit = Nolis[j].Unit == null || Nolis[j].Unit == "" ? "" : Nolis[j].Unit;
						unit = unit.replace("m3", "m³");
						unit = unit.replace("m2", "m²");
						//value
						var value = result.result[0][0][Columid] == null ? "" : result.result[0][0][Columid];
						strinfo += "<tr><td><p style=\"width:100%; display:inline-block; \" class='mui-ellipsis'>" + Nolis[j].Remark + ":" + value + (value == "" ? "" : unit) + "</p></td> <td> </td></tr > ";
					}
					strinfo += "</table>";
					//高亮显示
					var symbol1 = null;
					switch(idResult.feature.geometry.type) {
						case "polygon":
							{
								symbol1 = new esri.symbol.SimpleFillSymbol(esri.symbol.SimpleFillSymbol.STYLE_SOLID, new esri.symbol.SimpleLineSymbol(esri.symbol.SimpleLineSymbol.STYLE_DASHDOT, new esri.Color([255, 0, 0]), 2), new esri.Color([255, 0, 0, 0.25]));
								break;
							}
						case "polyline":
							{
								symbol1 = new esri.symbol.SimpleLineSymbol(esri.symbol.SimpleLineSymbol.STYLE_SOLID, new esri.Color([255, 0, 0]), 2)
								break;
							}
						case "point":
							{
								symbol1 = new esri.symbol.SimpleMarkerSymbol(esri.symbol.SimpleMarkerSymbol.STYLE_CIRCLE, 8, new esri.symbol.SimpleLineSymbol(esri.symbol.SimpleLineSymbol.STYLE_SOLID, new esri.Color([255, 0, 0]), 2), new esri.Color([255, 0, 0, 2]));
								break;
							}
					}
					//var infoTemplate = new esri.InfoTemplate();
					//infoTemplate.setContent(strinfo);
					//idResult.feature.setInfoTemplate(infoTemplate);
					idResult.feature.setSymbol(symbol1);
					LocationLayer.add(idResult.feature);
					map.infoWindow.setContent(strinfo);
					map.infoWindow.show(screenPoint, map.getInfoWindowAnchor(screenPoint));
				} else {
					mui.toast(idResult.feature.attributes["Name"] + " " + result.resultMessg);
				}
			} else {
				mui.toast("读取建筑物信息失败，请稍后重试。");
			}
		},
		error: function(XmlHttpRequest, textStatus, errorThrown) {
			mui.toast("服务连接失败，请稍后重试。");
		}
	});
	plus.nativeUI.closeWaiting();
}